<?php

function plugin_init_manage() {
	global $plugin_hooks;
	$plugin_hooks['top_header_tabs']['manage'] = 'manage_show_tab';	
	$plugin_hooks['top_graph_header_tabs']['manage'] = 'manage_show_tab';
	$plugin_hooks['config_arrays']['manage'] = 'manage_config_arrays';
	$plugin_hooks['poller_bottom']['manage'] = 'manage_poller_bottom';
	$plugin_hooks['draw_navigation_text']['manage'] = 'manage_draw_navigation_text';
	$plugin_hooks['config_form']['manage'] = 'manage_config_form';
	$plugin_hooks['api_device_save']['manage'] = 'manage_api_device_save';
	$plugin_hooks['config_settings']['manage'] = 'manage_config_settings';	
}

function manage_version () {
	return array( 'name' 		=> 'manage',
			'version' 	=> '0.4',
			'longname'	=> 'PHP Network Managing',
			'author'	=> 'Gilles Boulon',
			'homepage'	=> 'http://forums.cacti.net/viewtopic.php?t=13827',
			'email'		=> '',
			'url'		=> ''
			);
}

function manage_config_form () {
	global $fields_host_edit;
	$fields_host_edit2 = $fields_host_edit;
	$fields_host_edit3 = array();
	foreach ($fields_host_edit2 as $f => $a) {
		$fields_host_edit3[$f] = $a;
		if ($f == 'disabled') {
			$fields_host_edit3["manage"] = array(
				"method" => "checkbox",
				"friendly_name" => "Manage Host",
				"description" => "Check this box to manage this host.",
				"value" => "|arg1:manage|",
				"default" => "off",
				"form_id" => false
			);
		} 
	}
	$fields_host_edit = $fields_host_edit3;
}

function manage_setup_table () {
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");

	$install = "full";
//print " 1 ".$install;
	$sql = "show columns from host from `" . $database_default . "`";
	$result = mysql_query($sql) or die (mysql_error());
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		if ($row['Field'] == 'manage')
			$install = "upgrade-0.1";
	}
//print " 2 ".$install;
	$sql = "show tables from `" . $database_default . "`";
	$result = mysql_query($sql);
	while ($row = mysql_fetch_row($result)) {
	  if ($row[0] == "manage_host") {
	  	$sql2 = "show columns from manage_host from `" . $database_default . "`";
	    $result2 = mysql_query($sql2) or die (mysql_error());
	    while ($row2 = mysql_fetch_array($result2, MYSQL_ASSOC)) {
		  if ($row2['Field'] == 'force')
			$install = "upgrade-0.2";
	    }
	  }
	}
//print " 3 ".$install;
	if ($install <> "full") {
	  $sql = "show columns from manage_host from `" . $database_default . "`";
	  $result = mysql_query($sql) or die (mysql_error());
	  while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		if ($row['Field'] == 'group')
			$install = "upgrade-0.3";
	  }
	}
//print " 4 ".$install;
	$sql = "SELECT count(value) as total FROM settings where name='manage_poller_hosts'";
	$result = mysql_query($sql) or die (mysql_error());
    $row = mysql_fetch_array($result, MYSQL_ASSOC);
	if ($row['total'] == 1) {
      $install="";	
	}

//print " 5 ".$install;

	if ($install == "full") {
		$sql = "alter table host add manage char(3) default '' not null after disabled";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_host ( id mediumint(8) unsigned NOT NULL default '0', uptime bigint(20) default NULL, type mediumint(8) unsigned NOT NULL default '0', services text, statut text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_method ( id mediumint(8) unsigned NOT NULL default '0', method text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_alerts (idh mediumint(8) unsigned NOT NULL default '0', datetime datetime NOT NULL default '0000-00-00 00:00:00', ids mediumint(8) unsigned default '0', message text, note text, ida mediumint(9) unsigned NOT NULL auto_increment, PRIMARY KEY  (ida))";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_host_services ( id mediumint(8) unsigned NOT NULL default '0', services mediumint(8) unsigned default '', statut text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_events', '5')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_poller', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_method', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_date', '0')";
		$result = mysql_query($sql) or die (mysql_error());
	}

	if ( ($install == "full") || ($install == "upgrade-0.1") ) {
		$sql = "ALTER TABLE manage_host ADD `force` MEDIUMINT(8) unsigned NOT NULL default '9'";
		$result = mysql_query($sql) or die (mysql_error());			
		$sql = "CREATE TABLE manage_device_type ( id MEDIUMINT(8) NOT NULL AUTO_INCREMENT , name TEXT, image TEXT, PRIMARY KEY ( id ) )";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (1, 'Windows 2003 Host', 'win2003.png')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_device_type VALUES (2, 'Windows XP Host', NULL)";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_device_type VALUES (3, 'Windows 2000 Host', 'win2000.png')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_device_type VALUES (4, 'Windows NT4 Host', 'winnt.png')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_device_type VALUES (5, 'Windows 9x Host', NULL)";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_device_type VALUES (6, 'Linux Host', 'linux.png')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_device_type VALUES (7, 'Router', 'router.png')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_device_type VALUES (8, 'Switch', 'switch.png')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_device_type VALUES (9, 'Other', 'other.png')";
		$result = mysql_query($sql) or die (mysql_error());			
		$sql = "CREATE TABLE manage_templates ( id MEDIUMINT(8) NOT NULL auto_increment, name TEXT, tcp_ports TEXT, PRIMARY KEY  (id) )";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_templates VALUES (1, 'Mail Server (Basic)', '110;25')";
		$result = mysql_query($sql) or die (mysql_error());			
		$sql = "INSERT INTO manage_templates VALUES (2, 'Mail Server (Enhanced)', '110;995;25;143;993;80;443')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_templates VALUES (3, 'Switch/Router', '23')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_templates VALUES (4, 'Web Server', '80;443')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_templates VALUES (5, 'Windows 200x Domain Controler', '389')";
		$result = mysql_query($sql) or die (mysql_error());	
		$sql = "INSERT INTO manage_templates VALUES (6, 'DNS Server', '53')";
		$result = mysql_query($sql) or die (mysql_error());	
	}

	if ( ($install == "full") || ($install == "upgrade-0.1") || ($install == "upgrade-0.2") ) {
	  $sql = "alter table manage_host add `group` MEDIUMINT(8) default '0'";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "CREATE TABLE manage_groups ( id MEDIUMINT(8) NOT NULL auto_increment, name TEXT, PRIMARY KEY  (id) )";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO manage_groups VALUES (1, 'Test')";
	  $result = mysql_query($sql) or die (mysql_error());			
	}

	if ( ($install == "full") || ($install == "upgrade-0.1") || ($install == "upgrade-0.2") || ($install == "upgrade-0.3") ) {
	  $sql = "CREATE TABLE manage_services ( id MEDIUMINT(8) NOT NULL, name TEXT, oid TEXT, statut TEXT )";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "CREATE TABLE manage_process ( id MEDIUMINT(8) NOT NULL, name TEXT, tag TEXT, statut TEXT )";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "ALTER TABLE manage_alerts ADD `oid` TEXT";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO settings VALUES ('manage_use_patch', '0')";
	  $result = mysql_query($sql) or die (mysql_error());	  
	  $sql = "INSERT INTO settings VALUES ('manage_send', '')";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO settings VALUES ('manage_netsend_events', '5')";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO settings VALUES ('manage_netsend_method', '1')";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO settings VALUES ('manage_list', '0')";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO settings VALUES ('manage_list_separator', '25')";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO settings VALUES ('manage_full_separator', '6')";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO settings VALUES ('manage_simple_separator', '12')";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO settings VALUES ('manage_legend', 'on')";
	  $result = mysql_query($sql) or die (mysql_error());
	  $sql = "INSERT INTO settings VALUES ('manage_poller_hosts', '5')";
	  $result = mysql_query($sql) or die (mysql_error());
  }
	
	
}


function manage_poller_bottom () {
	global $config;

	manage_setup_table();
	$p = dirname(__FILE__);

	if ($config["cacti_server_os"] == "unix") {
		$command_string = read_config_option("path_php_binary");
		$extra_args = "-q " . $p . "/check-manage.php";
	} else {
	
	  $v = db_fetch_cell("SELECT value FROM settings where name='manage_use_patch'");
	  if ($v == 1) {
	    $command_string = $p . "/check-manage.bat";
		$extra_args = "";
	  } else {
	    $command_string = read_config_option("path_php_binary");
		$extra_args = "-q " . strtolower($p . "/check-manage.php");
	  }
	}
	$manage_poller = db_fetch_cell("select value from settings where name ='manage_poller'",'');
	if ($manage_poller == '0') {
	  exec_background($command_string, $extra_args);
	}
}


function manage_api_device_save ($save) {
	if (isset($_POST['manage']))
		$save["manage"] = form_input_validate($_POST['manage'], "manage", "", true, 3);
	else
		$save['manage'] = form_input_validate('', "manage", "", true, 3);
	return $save;
}


function manage_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames, $menu;
	$user_auth_realms[56]='Use Manage';
	$user_auth_realm_filenames['manage.php'] = 56;
	$user_auth_realm_filenames['list.php'] = 56;
	$user_auth_realm_filenames['viewalerts.php'] = 56;
	$user_auth_realm_filenames['types.php'] = 56;
    $user_auth_realm_filenames['templates.php'] = 56;
	$user_auth_realm_filenames['groups.php'] = 56;
	
	$menu["Templates"]['plugins/manage/templates.php'] = "Manage Templates";	
	
	$menu2 = array ();
	foreach ($menu as $temp => $temp2 ) {
		$menu2[$temp] = $temp2;
		if ($temp == 'Management') {
			$menu2["Device Managing"]['plugins/manage/list.php'] = "Devices";
			$menu2["Device Managing"]['plugins/manage/types.php'] = "Device Types";
			$menu2["Device Managing"]['plugins/manage/groups.php'] = "Groups";
			$menu2["Device Managing"]['plugins/manage/viewalerts.php'] = "Event Reporting";
		}
	}
	$menu = $menu2;
}





function manage_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
	$realm_id2 = 0;

	if (isset($user_auth_realm_filenames{basename('manage.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('manage.php')};
	}
	if ((db_fetch_assoc("select user_auth_realm.realm_id
		from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

		$v = read_config_option("manage_list");
		print '<a href="' . $config['url_path'] . 'plugins/manage/manage.php?simple='.$v.'"><img src="' . $config['url_path'] . 'plugins/manage/images/tab_manage.gif" alt="Manage" align="absmiddle" border="0"></a>';

	}
	manage_setup_table();
}


function manage_draw_navigation_text ($nav) {
  $nav["manage.php:"] = array("title" => "Manage", "mapping" => "index.php:", "url" => "manage.php", "level" => "1");
  $nav["list.php:"] = array("title" => "Device Managing -> Devices", "mapping" => "index.php:", "url" => "list.php", "level" => "1");
  $nav["list.php:edit"] = array("title" => "Device Managing ->   Devices", "mapping" => "index.php:", "url" => "list.php", "level" => "1");
  $nav["list.php:actions"] = array("title" => "Device Managing ->   Devices", "mapping" => "index.php:", "url" => "list.php", "level" => "1");
  $nav["viewalerts.php:"] = array("title" => "Device Managing -> Event Reporting", "mapping" => "index.php:", "url" => "viewalerts.php", "level" => "1");
  $nav["viewalerts.php:actions"] = array("title" => "Device Managing -> Event Reporting", "mapping" => "index.php:", "url" => "viewalerts.php", "level" => "1");
  $nav["types.php:"] = array("title" => "Device Managing -> Device Types", "mapping" => "index.php:", "url" => "types.php", "level" => "1");
  $nav["types.php:actions"] = array("title" => "Device Managing -> Device Types", "mapping" => "index.php:", "url" => "types.php", "level" => "1");
  $nav["templates.php:"] = array("title" => "Manage Templates", "mapping" => "index.php:", "url" => "templates.php", "level" => "1");
  $nav["templates.php:actions"] = array("title" => "Manage Templates", "mapping" => "index.php:", "url" => "templates.php", "level" => "1");  
  $nav["groups.php:"] = array("title" => "Manage Groups", "mapping" => "index.php:", "url" => "groups.php", "level" => "1");
  $nav["groups.php:actions"] = array("title" => "Manage Groups", "mapping" => "index.php:", "url" => "groups.php", "level" => "1");
  return $nav;
}


function manage_config_settings () {
	global $tabs, $settings;
	$tabs["misc"] = "Misc";
	
	$temp = array(
		"general_header" => array(
			"friendly_name" => "Plugin Manage",
			"method" => "spacer",
		),
		"manage_method" => array(
			"friendly_name" => "Method to test connexion with host",
			"description" => "SNMP is recommended.<br>NOTE: ICMP Ping requires that the Cacti Service ID have root privileges in Unix.",
			"method" => "drop_array",
			"array" => array(0 => 'SNMP (uptime check)', 1 => 'SNMP (sysdescr check)', 2 => 'UDP Ping (with risk)', 3 => 'ICMP Ping (with risk)' ),
		),
		"manage_poller" => array(
			"friendly_name" => "Type of poller",
			"description" => "You can use the default task Cacti poller. If you need a faster poller, scheduled another task with 'check-manage.php' (or 'check-manage.bat' if you want to use Windows PHP Patch).",
			"method" => "drop_array",
			"array" => array(0 => 'Cacti poller', 1 => 'Manage poller'),
		),
		"manage_use_patch" => array(
			"friendly_name" => "Use Windows PHP Patch",
			"description" => "Don't use.",
			"method" => "drop_array",
			"array" => array(0 => 'no', 1 => 'yes'),
		),
		"manage_events" => array(
			"friendly_name" => "Enable mail alerts",
			"description" => "",
			"method" => "drop_array",
			"array" => array(0 => 'UP events', 1 => 'DOWN events', 2 => 'Reboot events', 3 => 'UP and DOWN events', 4 => 'DOWN and reboot events', 5 => 'None'),
		),
		"manage_netsend_events" => array(
			"friendly_name" => "Enable 'net send' alerts",
			"description" => "",
			"method" => "drop_array",
			"array" => array(0 => 'UP events', 1 => 'DOWN events', 2 => 'Reboot events', 3 => 'UP and DOWN events', 4 => 'DOWN and reboot events', 5 => 'None'),
		),
		"manage_netsend_method" => array(
			"friendly_name" => "'net send' method",
			"description" => "Perl module need Net::NetSend and Net-Nslookup.",
			"method" => "drop_array",
			"array" => array(0 => 'Windows build-in command', 1 => 'Perl module'),
		),
		"manage_netsend_perl" => array(
			"friendly_name" => "Perl Binary Path",
			"description" => "The path to your perl binary.",
			"method" => "textbox",
			"default" => "c:/perl/bin/perl.exe",
			"max_length" => 255,
		),
		"manage_send" => array(
			"friendly_name" => "Stations that will receive 'net send' alerts.",
			"description" => "';' is separator. Windows stations only.",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_list" => array(
			"friendly_name" => "Default view",
			"description" => "",
			"method" => "drop_array",
			"array" => array(0 => 'Full', 1 => 'Simple', 2 => 'List'),
		),
		"manage_list_separator" => array(
			"friendly_name" => "List view separator",
			"description" => "",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_full_separator" => array(
			"friendly_name" => "Hosts per line in Full view",
			"description" => "",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_simple_separator" => array(
			"friendly_name" => "Hosts per line in Simple view",
			"description" => "",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_legend" => array(
			"friendly_name" => "Show Icon Legend",
			"description" => "Check this to show an icon legend on the Monitor display",
			"method" => "checkbox",
		),
		"manage_poller_hosts" => array(
			"friendly_name" => "How many concurrent Manage Pollers can be run.",
			"description" => "To speed up poller time, you can choose to distribute hosts you manage in multiples pollers which will be run in same time.",
			"method" => "textbox",
			"max_length" => 255,
		)
	);
	if (isset($settings["misc"]))
		$settings["misc"] = array_merge($settings["misc"], $temp);
	else
		$settings["misc"]=$temp;	
	
}


	
?>
